var Module;

if (typeof Module === 'undefined') Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

if (!Module.expectedDataFileDownloads) {
  Module.expectedDataFileDownloads = 0;
  Module.finishedDataFileDownloads = 0;
}
Module.expectedDataFileDownloads++;
(function() {
  var loadPackage = function(REQUEST_URI) {

  var metadata = {};
  metadata.uri = REQUEST_URI;
  metadata.file = REQUEST_URI.substring(REQUEST_URI.lastIndexOf('/') + 1);
  metadata.path = REQUEST_URI.substring(0, REQUEST_URI.lastIndexOf('/') + 1);
  metadata.uuid = btoa(metadata.uri);

  if (typeof Module['locateFilePackage'] === 'function' && !Module['locateFile']) {
    Module['locateFile'] = Module['locateFilePackage'];
    Module.printErr('warning: you defined Module.locateFilePackage, that has been renamed to Module.locateFile (using your locateFilePackage for now)');
  }

  //var REMOTE_PACKAGE_URI = typeof Module['locateFile'] === 'function' ?
  //Module['locateFile'](PACKAGE_FILE) : ((Module['filePackagePrefixURL'] || '') + PACKAGE_FILE);

  function runWithFS() {

    function assert(check, msg) {
      if (!check) throw msg + new Error().stack;
    }
    //{{{create_file_paths}}}

    function DataRequest(start, end, crunched, audio) {
      this.start = start;
      this.end = end;
      this.crunched = crunched;
      this.audio = audio;
    }
    DataRequest.prototype = {
      requests: {},
      open: function(mode, name) {
        this.name = name;
        this.requests[name] = this;
        Module['addRunDependency']('fp ' + name);
      },
      send: function() {},
      onload: function() {
        var byteArray = this.byteArray.subarray(this.start, this.end);
        this.finish(byteArray);
      },
      finish: function(byteArray) {
        var that = this;
        // canOwn this data in the filesystem, it is a slide into the heap that will never change
        Module['FS_createDataFile'](this.name, null, byteArray, true, true, true);
        Module['removeRunDependency']('fp ' + that.name);
        this.requests[this.name] = null;
      }
    };

    function executeDataRequests(size) {
      metadata.size = size;
      let req = new DataRequest(0, size, 0, false);
      req.open('GET', metadata.file);
    }

    function fetchRemotePackage(uri, callback) {
      // full path to the .love file
      let url = metadata.path + uri;
      let xhr = new XMLHttpRequest();
      xhr.open('GET', url, true);
      xhr.responseType = 'arraybuffer';
      xhr.onprogress = function(event) {
        if (event.total && metadata.size === undefined)
          executeDataRequests(event.total);

        if (event.loaded) {
          if (!xhr.addedTotal) {
            xhr.addedTotal = true;
            if (!Module.dataFileDownloads) Module.dataFileDownloads = {};
            Module.dataFileDownloads[url] = {
              loaded: event.loaded,
              total: metadata.size
            };
          } else {
            Module.dataFileDownloads[url].loaded = event.loaded;
          }
          let total = 0;
          let loaded = 0;
          let num = 0;
          for (let download in Module.dataFileDownloads) {
            let data = Module.dataFileDownloads[download];
            total += data.total;
            loaded += data.loaded;
            num ++;
          }
          total = Math.ceil(total * Module.expectedDataFileDownloads/num);
          if (Module['setStatus']) Module['setStatus'](loaded/total);
        } else if (!Module.dataFileDownloads) {
          if (Module['setStatus']) Module['setStatus']();
        }
      };
      xhr.onerror = function(event) {
        //throw new Error("NetworkError for: " + url);
        preloadFallback("NetworkError for: " + url);
      }
      xhr.onload = function(event) {
        if (xhr.status == 200 || xhr.status == 304 || xhr.status == 206 || (xhr.status == 0 && xhr.response)) // file URLs can return 0
          callback(xhr.response);
        else
          //throw new Error(xhr.statusText + " : " + xhr.responseURL);
          preloadFallback(xhr.statusText + " : " + xhr.responseURL);
      };
      xhr.send(null);
    };

    function handleError(error) {
      console.error('package error:', error);
    };

    var indexedDB = window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
    var IDB_RO = "readonly";
    var IDB_RW = "readwrite";
    var DB_NAME = "EM_PRELOAD_CACHE";
    var DB_VERSION = 1;
    var METADATA_STORE_NAME = 'METADATA';
    var PACKAGE_STORE_NAME = 'PACKAGES';
    function openDatabase(callback) {
      try {
        var openRequest = indexedDB.open(DB_NAME, DB_VERSION);
      } catch (e) {
        return preloadFallback(e);
      }
      openRequest.onupgradeneeded = function(event) {
        var db = event.target.result;

        if(db.objectStoreNames.contains(PACKAGE_STORE_NAME)) {
          db.deleteObjectStore(PACKAGE_STORE_NAME);
        }
        var packages = db.createObjectStore(PACKAGE_STORE_NAME);

        if(db.objectStoreNames.contains(METADATA_STORE_NAME)) {
          db.deleteObjectStore(METADATA_STORE_NAME);
        }
        var metadata = db.createObjectStore(METADATA_STORE_NAME);
      };
      openRequest.onsuccess = function(event) {
        var db = event.target.result;
        callback(db);
      };
      openRequest.onerror = function(error) {
        preloadFallback(error);
      };
    };

    /* Check if there's a cached package, and if so whether it's the latest available */
    function checkCachedPackage(db, packageName, callback) {
      var transaction = db.transaction([METADATA_STORE_NAME], IDB_RO);
      var meta = transaction.objectStore(METADATA_STORE_NAME);
      var getRequest = meta.get("metadata/" + packageName);
      getRequest.onsuccess = function(event) {
        var result = event.target.result;
        if (!result || metadata.uuid !== result.uuid) {
          return callback(false);
        } else {
          if (metadata.uuid === result.uuid)
            executeDataRequests(result.size);
          if (Module['setStatus']) Module['setStatus'](1);
          return callback(true);
        }
      };
      getRequest.onerror = function(error) {
        preloadFallback(error);
      };
    };

    function fetchCachedPackage(db, packageName, callback) {
      var transaction = db.transaction([PACKAGE_STORE_NAME], IDB_RO);
      var packages = transaction.objectStore(PACKAGE_STORE_NAME);
      var getRequest = packages.get("package/" + packageName);
      getRequest.onsuccess = function(event) {
        var result = event.target.result;
        callback(result);
      };
      getRequest.onerror = function(error) {
        preloadFallback(error);
      };
    };

    function cacheRemotePackage(db, packageName, packageData, packageMeta, callback) {
      var transaction_packages = db.transaction([PACKAGE_STORE_NAME], IDB_RW);
      var packages = transaction_packages.objectStore(PACKAGE_STORE_NAME);
      var putPackageRequest = packages.put(packageData, "package/" + packageName);
      putPackageRequest.onsuccess = function(event) {
        var transaction_metadata = db.transaction([METADATA_STORE_NAME], IDB_RW);
        var metadata = transaction_metadata.objectStore(METADATA_STORE_NAME);
        var putMetadataRequest = metadata.put(packageMeta, "metadata/" + packageName);
        putMetadataRequest.onsuccess = function(event) {
          callback(packageData);
        };
        putMetadataRequest.onerror = function(error) {
          preloadFallback(error);
        };
      };
      putPackageRequest.onerror = function(error) {
        preloadFallback(error);
      };
    };

    function processPackageData(arrayBuffer) {
      Module.finishedDataFileDownloads++;
      assert(arrayBuffer, 'Loading data file failed.');
      assert(arrayBuffer instanceof ArrayBuffer, 'bad input to processPackageData');
      var byteArray = new Uint8Array(arrayBuffer);
      var curr;
        // copy the entire loaded file into a spot in the heap. Files will refer to slices in that. They cannot be freed though
        // (we may be allocating before malloc is ready, during startup).
        if (Module['SPLIT_MEMORY']) Module.printErr('warning: you should run the file packager with --no-heap-copy when SPLIT_MEMORY is used, otherwise copying into the heap may fail due to the splitting');
        var ptr = Module['getMemory'](byteArray.length);
        Module['HEAPU8'].set(byteArray, ptr);
        DataRequest.prototype.byteArray = Module['HEAPU8'].subarray(ptr, ptr+byteArray.length);
        DataRequest.prototype.requests[metadata.file].onload();

        //Module['removeRunDependency']('datafile_game.data');
        Module['removeRunDependency']('datafile_'+metadata.file);
      };

      function preloadFallback(error) {
        console.error(error);
        //console.error('falling back to default preload behavior');
        //fetchRemotePackage(metadata.file, processPackageData, handleError);        
        if (metadata.file != 'nogame.love') {
          metadata.path = '';
          metadata.file = 'nogame.love';
          metadata.uri = 'nogame.love';
          metadata.uuid = btoa(metadata.uri);
          metadata.size = undefined;
          Module['addRunDependency']('datafile_'+metadata.file);
          Module['arguments'] = ['nogame.love'];
          
          fetchRemotePackage(metadata.file, processPackageData);
          Love(Module);
        }
      };

      openDatabase(
        function(db) {
          checkCachedPackage(db, metadata.file,
            function(useCached) {
              if (NOCACHE)
                useCached = false;
              //Module.preloadResults[metadata.file] = {fromCache: useCached};
              if (useCached) {
                console.info('loading ' + metadata.file + ' from cache');
                fetchCachedPackage(db, metadata.file, processPackageData);
              } else {
                console.info('loading ' + metadata.file + ' from remote');
                fetchRemotePackage(metadata.file, 
                  function(packageData) {
                    cacheRemotePackage(db, metadata.file, packageData, metadata, processPackageData,
                      function(error) {
                        console.error(error);
                        processPackageData(packageData);
                      });
                  });
              }
            });
        });

      //Module['addRunDependency']('datafile_game.data');
      Module['addRunDependency']('datafile_'+metadata.file);
      //if (!Module.preloadResults) Module.preloadResults = {};
      if (Module['setStatus']) Module['setStatus'](0);
    }

    if (Module['calledRun']) {
      runWithFS();
    } else {
      if (!Module['preRun']) Module['preRun'] = [];
      Module["preRun"].push(runWithFS); // FS is not initialized yet, wait for it
    }
  }
  
  loadPackage(REQUEST_URI || "nogame.love");

})();
